using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using VidGrab;

namespace AsynchronousStartFromThread
{

    public partial class Form1 : Form
    {

        public void EnableVgButtons(bool Started)
        {
            /*if (InvokeRequired)
            {
                BeginInvoke((Action<bool>)EnableVgButtons, Started);
            }
            else
            {*/
                btnStartPreview.Enabled = !Started;
                btnCaptureToControl.Enabled = Started;
                btnCaptureToPng.Enabled = Started;
                btnStopPreview.Enabled = Started;
            //}
        }

        public Form1()
        {
            InitializeComponent();
        }

        VideoGrabberThreadObject vgObject = null;

        private void btnStartPreview_Click(object sender, EventArgs e)
        {
            if (vgObject == null)
            {
                vgObject = new VideoGrabberThreadObject(this, panelDisplay, edtIPCameraURL.Text);
            }
        }


        private void btnCaptureToControl_Click(object sender, EventArgs e)
        {
            System.IntPtr FrameBitmap = vgObject.VideoGrabber.GetLastFrameAsHBITMAP(0, false, 0, 0, 0, 0, imgCapturedFrame.Width, imgCapturedFrame.Height, 32);
            if (!FrameBitmap.Equals(System.IntPtr.Zero))
            {
                imgCapturedFrame.Image = Image.FromHbitmap(FrameBitmap);
                WinUtil.DeleteObject(FrameBitmap);
            }

        }

        private void btnCaptureToPng_Click(object sender, EventArgs e)
        {
            System.IntPtr FrameBitmap = vgObject.VideoGrabber.GetLastFrameAsHBITMAP(0, false, 0, 0, 0, 0, 0, 0, 32);
            if (!FrameBitmap.Equals(System.IntPtr.Zero))
            {
                Image img = Image.FromHbitmap(FrameBitmap);
                img.Save("CapturedFrame.png", System.Drawing.Imaging.ImageFormat.Png);
                WinUtil.DeleteObject(FrameBitmap);
            }

        }

        private void btnStopPreview_Click(object sender, EventArgs e)
        {
            if (vgObject != null)
            {
                EnableVgButtons(false);
                vgObject.Dispose();
                vgObject = null;
            }

        }

    }


    class VideoGrabberThreadObject : VideoGrabberThread
    {
        private string m_IPCameraURL = "";
        private Form1 m_Form1;

        public VideoGrabberThreadObject(Form1 OwnerForm, Control ParentControl, string IPCameraURL)
            : base(ParentControl)
        {
            m_IPCameraURL = IPCameraURL;
            m_Form1 = OwnerForm;
            Thread.Priority = System.Threading.ThreadPriority.Normal;
            Thread.Start();
        }

        protected override void VideoGrabberThreadFunc()
        {
            VideoGrabber.VideoSource = TVideoSource.vs_IPCamera;
            VideoGrabber.IPCameraURL = m_IPCameraURL;
            VideoGrabber.OnPreviewStarted += new EventHandler(VideoGrabber_OnPreviewStarted);
            if (VideoGrabber.StartPreview())
            {
                //... preview started
            }
        }


        private void VideoGrabber_OnPreviewStarted(object sender, EventArgs e) 
        {
            m_Form1.Invoke(new MethodInvoker(delegate {
                m_Form1.EnableVgButtons(true);
            }));
        }
    }


}
